Design and implement a data structure for a Least Frequently Used (LFU) cache.
Implement the LFUCache
class:
-
LFUCache(int capacity)
Initializes the object with thecapacity
of the data structure. -
int get(int key)
Gets the value of thekey
if thekey
exists in the cache. Otherwise, returns-1
. -
void put(int key, int value)
Update the value of thekey
if present, or inserts thekey
if not already present. When the cache reaches itscapacity
, it should invalidate and remove the least frequently used key before inserting a new item. For this problem, when there is a tie (i.e., two or more keys with the same frequency), the least recently usedkey
would be invalidated.
To determine the least frequently used key, a use counter is maintained for each key in the cache. The key with the smallest use counter is the least frequently used key.
When a key is first inserted into the cache, its use counter is set to 1
(due to the put
operation). The use counter for a key in the cache is incremented either a get
or put
operation is called on it.
The functions get
and put
must each run in O(1)
average time complexity.
Example 1:
Input ["LFUCache", "put", "put", "get", "put", "get", "get", "put", "get", "get", "get"] [[2], [1, 1], [2, 2], [1], [3, 3], [2], [3], [4, 4], [1], [3], [4]] Output [null, null, null, 1, null, -1, 3, null, -1, 3, 4] Explanation // cnt(x) = the use counter for key x // cache=[] will show the last used order for tiebreakers (leftmost element is most recent) LFUCache lfu = new LFUCache(2); lfu.put(1, 1); // cache=[1,_], cnt(1)=1 lfu.put(2, 2); // cache=[2,1], cnt(2)=1, cnt(1)=1 lfu.get(1); // return 1 // cache=[1,2], cnt(2)=1, cnt(1)=2 lfu.put(3, 3); // 2 is the LFU key because cnt(2)=1 is the smallest, invalidate 2. // cache=[3,1], cnt(3)=1, cnt(1)=2 lfu.get(2); // return -1 (not found) lfu.get(3); // return 3 // cache=[3,1], cnt(3)=2, cnt(1)=2 lfu.put(4, 4); // Both 1 and 3 have the same cnt, but 1 is LRU, invalidate 1. // cache=[4,3], cnt(4)=1, cnt(3)=2 lfu.get(1); // return -1 (not found) lfu.get(3); // return 3 // cache=[3,4], cnt(4)=1, cnt(3)=3 lfu.get(4); // return 4 // cache=[3,4], cnt(4)=2, cnt(3)=3
参考:https://leetcode.com/problems/lfu-cache/discuss/94521/JAVA-O(1)-very-easy-solution-using-3-HashMaps-and-LinkedHashSet
没啥好说的,直接抄吧
public class LFUCache { private int min; private final int capacity; //keyToVal存储每次put的value private final HashMap<Integer, Integer> keyToVal; //keyToCount存储访问次数 private final HashMap<Integer, Integer> keyToCount; private final HashMap<Integer, LinkedHashSet<Integer>> countToLRUKeys; public LFUCache(int capacity) { this.min = -1; this.capacity = capacity; this.keyToVal = new HashMap<>(); this.keyToCount = new HashMap<>(); this.countToLRUKeys = new HashMap<>(); } public int get(int key) { if (!keyToVal.containsKey(key)) return -1; int count = keyToCount.get(key); countToLRUKeys.get(count).remove(key); //从当前计数中删除键(因为我们将重新计算计数)remove key from current count (since we will inc count) if (count == min && countToLRUKeys.get(count).size() == 0) min++; // nothing in the current min bucket 当前最小存储桶中没有任何内容的时候,min++ //添加和返回个数,每get+1,访问次数+1 putCount(key, count + 1); return keyToVal.get(key); } public void put(int key, int value) { if (capacity <= 0) return; if (keyToVal.containsKey(key)) { keyToVal.put(key, value); //更新key update key's value get(key); //更新密钥的count update key's count return; } if (keyToVal.size() >= capacity) evict(countToLRUKeys.get(min).iterator().next()); // evict LRU from this min count bucket 从这个最小计数桶中驱逐最不常读取的元素LRU min = 1; //min 重新计算为1 putCount(key, min); //adding new key and count 添加新键和计数 keyToVal.put(key, value); //adding new key and value 添加新的键和值 } //从两个map中删掉 private void evict(int key) { countToLRUKeys.get(min).remove(key); keyToVal.remove(key); } //给两个map添加count private void putCount(int key, int count) { keyToCount.put(key, count); countToLRUKeys.computeIfAbsent(count, ignore -> new LinkedHashSet<>()); countToLRUKeys.get(count).add(key); } }